import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;


/**
 * Write a description of class Wall here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class mushroomWorld  extends World
{
private long musicPlay, musicBase;
private int past = 0;
public int level = 0;
static  GreenfootImage background;
GreenfootSound sound=new GreenfootSound ("music.wav");
GreenfootSound matrix=new GreenfootSound ("matrix.wav");
private boolean matri = false;






    /**
     * Constructor for objects of class Wall.
     * 
     */
    public mushroomWorld()
    { 
     
      
        // Create a new world with 1200x600 cells with a cell size of 1x1 pixels.
        super(1200, 600, 1); 
        prepare();
        setPaintOrder(endCredits.class,endGame.class, levelCompleted.class, gameOver.class,Enemies.class, Player.class, exitDoor.class, ground.class, brick.class);
        Greenfoot.setSpeed(50);
        

    }
    
   //public void started()
    //{
      //  musicBase = System.currentTimeMillis();
        //Greenfoot.playSound("music.wav");
    //} 
    
    
    private void prepare()
    {

    background = new GreenfootImage("weave.jpg");
    setBackground(background);  
    Player player = new Player();
    addObject (player, 30, 520);
    addObject (new jumpingSkull(), 275, 396);
    addObject (new jumpingSkull(), 370, 510);
    addObject (new exitDoor(), 1173, 277);
    addObject (new jumpingSkull(), 211, 156); 
    addObject (new rightRotateSkull(), 832, 374);
    addObject (new rightRotateSkull(), 847, 43);
    addObject (new leftRotateSkull(), 590, 290);
    
    addObject (new ground(), 90 , 555 );
    addObject (new ground(), 275 , 555 );
    addObject (new ground(), 460 , 555 );
    addObject (new ground(), 645 , 555 );
    addObject (new ground(), 838 , 493 );
    addObject (new ground(), 657 , 423 );
    addObject (new ground(), 530 , 353 );
    addObject (new ground(), 336 , 285 );
    addObject (new ground(), 154 , 216 );
    addObject (new ground(), 336 , 147 );
    addObject (new ground(), 592 , 147 );
    addObject (new ground(), 845 , 147 );
    addObject (new ground(), 1112 , 322 );
    addObject (new mushroom(), 135 , 509 );
    addObject (new mushroom(), 569 , 514 );
    addObject (new mushroom(), 829 , 446 );
    addObject (new mushroom(), 577 , 312 );
    addObject (new mushroom(), 264 , 508 );
    addObject (new mushroom(), 718 , 49 );
    addObject (new mushroom(), 465 , 49 );
    addObject (new brick(), 322 , 537 );
    addObject (new brick(), 322 , 303 );
    
    
    addObject (new verticalBall(), 322 , 418 );
    addObject (new niceBear(), 103 , 173 );
    
    
}

 public void act()
{
    musicPlay = System.currentTimeMillis();
    if(musicPlay-musicBase>144000)
    {
        
        sound.play();
        musicBase = musicPlay;
    }
    
        
  
} 

 

     public void end() 
    {
        if (level==1)
        {
            addObject(new levelCompleted(), getWidth()/2, getHeight()/2);
            Greenfoot.delay(120);
            addObject (new endGame(), 600 , 299 );
            addObject (new endCredits(), 604 , 295 );  
            sound.stop();
            Greenfoot.playSound("champion.wav");
            Greenfoot.stop();
            
        }
        addObject(new levelCompleted(), getWidth()/2, getHeight()/2);
        level++;
        

    }
    
   
       public void checkPast()
           
    {
           
            getBackground().setColor(Color.BLACK);
            getBackground().fill();   
            addObject (new blackJumpingSkull(), 1170 , 272 );
            addObject (new blackJumpingSkull(), 1054 , 225 );
            addObject (new blackJumpingSkull(), 1110 , 189 );
            addObject (new evilBear(),103, 173);
            Greenfoot.playSound("haha.wav");
            
           
        }             
          
            
       public void Level ()
       {
           if (level >=1)
           {
            background = new GreenfootImage("fingerprint.jpg");
            setBackground(background);
            cleanLevel();
            
            addObject (new  Player(), 42, 132);
            addObject (new ground(), 93 , 170 );
            addObject (new ground(), 278 , 170 );
            addObject (new ground(), 463 , 170 );
            addObject (new ground(), 646 , 170 );
            addObject (new ground(), 830 , 170 );
            addObject (new ground(), 1015 , 170 );
            
            addObject (new ground(), 93 , 9 );
            addObject (new ground(), 278 , 9 );
            addObject (new ground(), 463 , 9 );
            addObject (new ground(), 646 , 9 );
            addObject (new ground(), 830 , 9 );
            addObject (new ground(), 1015 , 9 );
            addObject (new ground(), 1154 , 9 );
            
           
            addObject (new ground(), 379 , 318 );
            addObject (new ground(), 562 , 318 );
            addObject (new ground(), 745 , 318 );
            addObject (new ground(), 928 , 318 );
            addObject (new ground(), 1111 , 318 );
            addObject (new ground(), 82 , 470 );
            addObject (new ground(), 263 , 470 );
            addObject (new ground(), 445 , 470 );
            addObject (new ground(), 693 , 425 );
            addObject (new ground(), 916 , 482 );
            
            addObject (new ground(), 1170 , 530 );
            addObject (new ground(), 462 , 596 );
            addObject (new ground(), 279 , 596 );
            addObject (new ground(), 95 , 596 );
            addObject (new ground(), 647 , 596 );
            addObject (new ground(), 831 , 596 );
            addObject (new ground(), 1014 , 596 );
            addObject (new ground(), 1186 , 596 );
            
            
            
            
            addObject (new brick(), 150 , 5 );
            addObject (new brick(), 150 , 174 );
            addObject (new verticalBall(), 150 , 40 );
            
            addObject (new brick(), 250 , 174 );
            addObject (new brick(), 250 , 5 );
            addObject (new verticalBall(), 250 , 140 );
            
            addObject (new brick(), 350 , 5 );
            addObject (new brick(), 350 , 174 );
            addObject (new verticalBall(), 350 , 45 );
            
            addObject (new brick(), 450 , 5 );
            addObject (new brick(), 450 , 174 );
            addObject (new verticalBall(), 450 , 140 );
            
            addObject (new brick(), 550 , 5 );
            addObject (new brick(), 550 , 174 );
            addObject (new verticalBall(), 550 , 45 );
            
            addObject (new brick(), 650 , 5 );
            addObject (new brick(), 650 , 174 );
            addObject (new verticalBall(), 650 , 140 );            
            
            addObject (new brick(), 750 , 5 );
            addObject (new brick(), 750 , 174 );
            addObject (new verticalBall(), 750 , 45 );  
            
            addObject (new brick(), 850 , 5 );
            addObject (new brick(), 850 , 174 );
            addObject (new verticalBall(), 850 , 140 );                 
                            
            addObject (new brick(), 950 , 5 );
            addObject (new brick(), 950 , 174 );
            addObject (new verticalBall(), 950 , 45 ); 
            
            addObject (new brick(), 1050 , 5 );
            addObject (new brick(), 1050 , 174 );
            addObject (new verticalBall(), 1050 , 140 );
            
                
                    
            
            
            addObject (new blackJumpingSkull(), 98, 372);
            addObject (new blackJumpingSkull(), 35, 418);
            addObject (new blackJumpingSkull(), 158, 418);
            
            addObject (new horizontalBall(), 302, 204);
            addObject (new horizontalBall(), 576, 228);
            addObject (new horizontalBall(), 895, 254);
            addObject (new horizontalBall(), 1012, 570);
            addObject (new horizontalBall(), 1087, 555);
            addObject (new horizontalBall(), 538, 555);
            addObject (new jumpingSkull(), 1043, 439);
            
            
            
            addObject (new mushroom(), 98 , 430 );
            addObject (new mushroom(), 302 , 49 );
            addObject (new mushroom(), 504 , 131 );
            addObject (new mushroom(), 808 , 50 );
            addObject (new mushroom(), 1001 , 246 );
            addObject (new mushroom(), 633 , 385 );
            addObject (new mushroom(), 926 , 445 );
            
            addObject (new greenMush(), 205, 132);
            
                        
            addObject (new exitDoor(), 59 , 551 );
        }
            }
            
            public void cleanLevel()
            {
               this.removeObjects( this.getObjects(brick.class) );
               this.removeObjects( this.getObjects(ground.class) );
               this.removeObjects( this.getObjects(Enemies.class) );   
               this.removeObjects( this.getObjects(levelCompleted.class) );
               this.removeObjects( this.getObjects(niceBear.class) );
               this.removeObjects( this.getObjects(Player.class) );
               this.removeObjects( this.getObjects(exitDoor.class) );
               this.removeObjects( this.getObjects(mushroom.class) );
               this.removeObjects( this.getObjects(evilBear.class) );
               this.removeObjects( this.getObjects(levelCompleted.class) );
               this.removeObjects( this.getObjects(gameOver.class) );
            }
                
        
      public void gameOver() 
    {
        Greenfoot.setSpeed(50);
        
        if (matri = true)
        {
            matrix.stop();
            sound.play();
        }
        
            if (level ==0)
            {
              addObject(new gameOver(), getWidth()/2, getHeight()/2);
              Greenfoot.delay(120);
              cleanLevel();
              prepare();
            }
            
            if (level ==1)
            {
                addObject(new gameOver(), getWidth()/2, getHeight()/2);
                Greenfoot.delay(120);
                Level();
            }
            
     
        }
        
        public void greenMush()
        {
            
            sound.pause();
            matrix.play();
            matri = true;
            
        }
        
        public void endMat()
        {
            Greenfoot.setSpeed(50);
            matrix.stop();
            sound.play();
        }
             
        
      
    
 
                     

       
    }



